aboutsummaryrefslogtreecommitdiffstats
path: root/resources/libraries/bash/function/device.sh
diff options
context:
space:
mode:
Diffstat (limited to 'resources/libraries/bash/function/device.sh')
-rw-r--r--resources/libraries/bash/function/device.sh354
1 files changed, 273 insertions, 81 deletions
diff --git a/resources/libraries/bash/function/device.sh b/resources/libraries/bash/function/device.sh
index cd987cafd2..4d39cd2de6 100644
--- a/resources/libraries/bash/function/device.sh
+++ b/resources/libraries/bash/function/device.sh
@@ -1,4 +1,4 @@
-# Copyright (c) 2021 Cisco and/or its affiliates.
+# Copyright (c) 2024 Cisco and/or its affiliates.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
@@ -30,6 +30,7 @@ function activate_wrapper () {
enter_mutex || die
get_available_interfaces "${1}" "${2}" || die
+ bind_dut_interfaces_to_vpp_driver || die
start_topology_containers "${3}" || die
bind_interfaces_to_containers || die
set_env_variables || die
@@ -38,6 +39,29 @@ function activate_wrapper () {
}
+function bind_dut_interfaces_to_vpp_driver () {
+
+ # Bind DUT network interfaces to the driver that vpp will use
+ #
+ # Variables read:
+ # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
+ # Variables set:
+ # - NETDEV - Linux network interface.
+ # - DRIVER - Kernel driver to bind the interface to.
+ # - KRN_DRIVER - The original kernel driver of the network interface.
+
+ for NETDEV in "${DUT1_NETDEVS[@]}"; do
+ get_pci_addr || die
+ get_krn_driver || die
+ if [[ ${KRN_DRIVER} == "iavf" ]]; then
+ DRIVER="vfio-pci"
+ ADDR=${PCI_ADDR}
+ bind_interfaces_to_driver || die
+ fi
+ done
+}
+
+
function bind_interfaces_to_containers () {
# Bind linux network interface to container and create symlink for PCI
@@ -51,36 +75,42 @@ function bind_interfaces_to_containers () {
# - TG_NETDEVS - List of network devices allocated to TG container.
# Variables set:
# - NETDEV - Linux network interface.
+ # - KRN_DRIVER - Kernel driver of network device.
set -exuo pipefail
- for NETDEV in "${TG_NETDEVS[@]}"; do
- get_pci_addr || die
+ for PCI_ADDR in "${TG_PCIDEVS[@]}"; do
+ get_netdev_name || die
link_target=$(readlink -f /sys/bus/pci/devices/"${PCI_ADDR}") || {
die "Reading symlink for PCI address failed!"
}
cmd="ln -s ${link_target} /sys/bus/pci/devices/${PCI_ADDR}"
- sudo ip link set ${NETDEV} netns ${DCR_CPIDS[tg]} || {
- die "Moving interface to ${DCR_CPIDS[tg]} namespace failed!"
- }
docker exec "${DCR_UUIDS[tg]}" ${cmd} || {
die "Linking PCI address in container failed!"
}
+
+ sudo ip link set ${NETDEV} netns ${DCR_CPIDS[tg]} || {
+ die "Moving interface to ${DCR_CPIDS[tg]} namespace failed!"
+ }
done
- for NETDEV in "${DUT1_NETDEVS[@]}"; do
- get_pci_addr || die
+ for PCI_ADDR in "${DUT1_PCIDEVS[@]}"; do
link_target=$(readlink -f /sys/bus/pci/devices/"${PCI_ADDR}") || {
die "Reading symlink for PCI address failed!"
}
cmd="ln -s ${link_target} /sys/bus/pci/devices/${PCI_ADDR}"
- sudo ip link set ${NETDEV} netns ${DCR_CPIDS[dut1]} || {
- die "Moving interface to ${DCR_CPIDS[dut1]} namespace failed!"
- }
- docker exec "${DCR_UUIDS[dut1]}" ${cmd} || {
+ docker exec "${DCR_UUIDS[dut1]}" ${cmd} || {
die "Linking PCI address in container failed!"
}
+
+ get_krn_driver
+ if [[ ${KRN_DRIVER} != "vfio-pci" ]]; then
+ get_netdev_name || die
+ sudo ip link set ${NETDEV} netns ${DCR_CPIDS[dut1]} || {
+ die "Moving interface to ${DCR_CPIDS[dut1]} namespace failed!"
+ }
+ fi
done
}
@@ -99,13 +129,22 @@ function bind_interfaces_to_driver () {
pci_path="/sys/bus/pci/devices/${ADDR}"
drv_path="/sys/bus/pci/drivers/${DRIVER}"
if [ -d "${pci_path}/driver" ]; then
- echo ${ADDR} | sudo tee ${pci_path}/driver/unbind || {
+ echo ${ADDR} | sudo tee ${pci_path}/driver/unbind > /dev/null || {
die "Failed to unbind interface ${ADDR}!"
}
fi
- echo ${ADDR} | sudo tee ${drv_path}/bind || {
+
+ echo ${DRIVER} | sudo tee /sys/bus/pci/devices/${ADDR}/driver_override \
+ > /dev/null || {
+ die "Failed to override driver to ${DRIVER} for ${ADDR}!"
+ }
+
+ echo ${ADDR} | sudo tee ${drv_path}/bind > /dev/null || {
die "Failed to bind interface ${ADDR}!"
}
+
+ echo | sudo tee /sys/bus/pci/devices/${ADDR}/driver_override > /dev/null \
+ || die "Failed to reset driver override for ${ADDR}!"
}
@@ -134,13 +173,17 @@ function clean_environment () {
}
# Rebind interfaces back to kernel drivers.
+ i=0
for ADDR in ${TG_PCIDEVS[@]}; do
- DRIVER="${TG_DRIVERS[0]}"
+ DRIVER="${TG_DRIVERS[${i}]}"
bind_interfaces_to_driver || die
+ ((i++))
done
+ i=0
for ADDR in ${DUT1_PCIDEVS[@]}; do
- DRIVER="${DUT1_DRIVERS[0]}"
+ DRIVER="${DUT1_DRIVERS[${i}]}"
bind_interfaces_to_driver || die
+ ((i++))
done
}
@@ -245,16 +288,20 @@ function get_available_interfaces () {
# - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
# - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
# - DUT1_DRIVERS - List of interface drivers to DUT1 container.
+ # - DUT1_VLANS - List of interface vlans to TG container.
+ # - DUT1_MODEL - List of interface models to TG container.
# - TG_NETDEVS - List of network devices allocated to TG container.
# - TG_PCIDEVS - List of PCI addresses allocated to TG container.
# - TG_NETMACS - List of MAC addresses allocated to TG container.
# - TG_DRIVERS - List of interface drivers to TG container.
+ # - TG_VLANS - List of interface vlans to TG container.
+ # - TG_MODEL - List of interface models to TG container.
set -exuo pipefail
- # Following code is specifing VFs ID based on nodeness and flavor.
+ # Following code is specifying VFs ID based on nodeness and flavor.
# As there is great variability in hardware configuration outside LF,
- # from bootstrap architecure point of view these are considered as flavors.
+ # from bootstrap architecture point of view these are considered as flavors.
# Anyone can override flavor for its own machine and add condition here.
# See http://pci-ids.ucw.cz/v2.2/pci.ids for more info.
case_text="${1}_${2}"
@@ -262,22 +309,30 @@ function get_available_interfaces () {
"1n_skx")
# Add Intel Corporation XL710/X710 Virtual Function to the
# whitelist.
- pci_id="0x154c"
- tg_netdev=(enp24)
- dut1_netdev=(enp59)
+ # Add Intel Corporation E810 Virtual Function to the
+ # whitelist.
+ pci_id="0x154c\|0x1889"
+ tg_netdev=(ens1 enp134)
+ dut1_netdev=(ens5 enp175)
+ ports_per_nic=2
;;
- "1n_tx2")
+ "1n_alt")
# Add Intel Corporation XL710/X710 Virtual Function to the
# whitelist.
- pci_id="0x154c"
- tg_netdev=(enp5s2 enp5s3 enp5s4 enp5s5
- enp5s6 enp5s7 enp5s8 enp5s9)
- tg_netdev+=(enp5s10 enp5s11 enp5s12 enp5s13
- enp5s14 enp5s15 enp5s16 enp5s17)
- dut1_netdev=(enp145s2 enp145s3 enp145s4 enp145s5
- enp145s6 enp145s7 enp145s8 enp145s9)
- dut1_netdev+=(enp145s10 enp145s11 enp145s12 enp145s13
- enp145s14 enp145s15 enp145s16 enp145s17)
+ # Add MT2892 Family [ConnectX-6 Dx] Virtual Function to the
+ # whitelist.
+ pci_id="0x154c\|0x101e"
+ tg_netdev=(enp1s0f0 enp1s0f1 enP1p1s0f0)
+ dut1_netdev=(enP3p2s0f0 enP3p2s0f1 enP1p1s0f1)
+ ports_per_nic=2
+ ;;
+ "1n_spr")
+ # Add Intel Corporation E810 Virtual Function to the
+ # whitelist.
+ pci_id="0x1889"
+ tg_netdev=(enp42s0 enp44s0)
+ dut1_netdev=(enp63s0 enp61s0)
+ ports_per_nic=1
;;
"1n_vbox")
# Add Intel Corporation 82545EM Gigabit Ethernet Controller to the
@@ -285,43 +340,47 @@ function get_available_interfaces () {
pci_id="0x100f"
tg_netdev=(enp0s8 enp0s9)
dut1_netdev=(enp0s16 enp0s17)
+ ports_per_nic=1
;;
*)
die "Unknown specification: ${case_text}!"
esac
- device_count=2
-
# TG side of connections.
TG_NETDEVS=()
TG_PCIDEVS=()
TG_NETMACS=()
TG_DRIVERS=()
TG_VLANS=()
+ TG_MODEL=()
# DUT1 side of connections.
DUT1_NETDEVS=()
DUT1_PCIDEVS=()
DUT1_NETMACS=()
DUT1_DRIVERS=()
DUT1_VLANS=()
+ DUT1_MODEL=()
# Find the first ${device_count} number of available TG Linux network
# VF device names. Only allowed VF PCI IDs are filtered.
for netdev in ${tg_netdev[@]}
do
+ ports=0
for netdev_path in $(grep -l "${pci_id}" \
/sys/class/net/${netdev}*/device/device \
2> /dev/null)
do
- if [[ ${#TG_NETDEVS[@]} -lt ${device_count} ]]; then
+ if [[ ${ports} -lt ${ports_per_nic} ]]; then
tg_netdev_name=$(dirname ${netdev_path})
tg_netdev_name=$(dirname ${tg_netdev_name})
TG_NETDEVS+=($(basename ${tg_netdev_name}))
+ ((ports++))
else
break
fi
done
- if [[ ${#TG_NETDEVS[@]} -eq ${device_count} ]]; then
+ ports_per_device=$((${ports_per_nic}*${#tg_netdev[@]}))
+ if [[ ${#TG_NETDEVS[@]} -eq ${ports_per_device} ]]; then
break
fi
done
@@ -345,29 +404,30 @@ function get_available_interfaces () {
get_mac_addr
get_krn_driver
get_vlan_filter
+ get_csit_model
TG_PCIDEVS+=(${PCI_ADDR})
TG_NETMACS+=(${MAC_ADDR})
TG_DRIVERS+=(${KRN_DRIVER})
TG_VLANS+=(${VLAN_ID})
+ TG_MODELS+=(${MODEL})
done
for NETDEV in "${DUT1_NETDEVS[@]}"; do
get_pci_addr
get_mac_addr
get_krn_driver
get_vlan_filter
+ get_csit_model
DUT1_PCIDEVS+=(${PCI_ADDR})
DUT1_NETMACS+=(${MAC_ADDR})
DUT1_DRIVERS+=(${KRN_DRIVER})
DUT1_VLANS+=(${VLAN_ID})
+ DUT1_MODELS+=(${MODEL})
done
# We need at least two interfaces for TG/DUT1 for building topology.
- if [ "${#TG_NETDEVS[@]}" -ne 2 ] || [ "${#DUT1_NETDEVS[@]}" -ne 2 ]; then
+ if [ "${#TG_NETDEVS[@]}" -lt 2 ] || [ "${#DUT1_NETDEVS[@]}" -lt 2 ]; then
die "Not enough linux network interfaces found!"
fi
- if [ "${#TG_PCIDEVS[@]}" -ne 2 ] || [ "${#DUT1_PCIDEVS[@]}" -ne 2 ]; then
- die "Not enough pci interfaces found!"
- fi
}
@@ -408,6 +468,57 @@ function get_mac_addr () {
}
+function get_netdev_name () {
+
+ # Get Linux network device name.
+ #
+ # Variables read:
+ # - PCI_ADDR - PCI address of the device.
+ # Variables set:
+ # - NETDEV - Linux network device name.
+
+ set -exuo pipefail
+
+ if [ -d /sys/bus/pci/devices/${PCI_ADDR}/net ]; then
+ NETDEV="$(basename /sys/bus/pci/devices/${PCI_ADDR}/net/*)" || {
+ die "Failed to get Linux interface name of ${PCI_ADDR}"
+ }
+ fi
+}
+
+
+function get_csit_model () {
+
+ # Get CSIT model name from linux network device name.
+ #
+ # Variables read:
+ # - NETDEV - Linux network device name.
+ # Variables set:
+ # - MODEL - CSIT model name of network device.
+
+ set -exuo pipefail
+
+ if [ -d /sys/class/net/${NETDEV}/device ]; then
+ ID="$(</sys/class/net/${NETDEV}/device/device)" || {
+ die "Failed to get device id of linux network interface!"
+ }
+ case "${ID}" in
+ "0x1592"|"0x1889")
+ MODEL="Intel-E810CQ"
+ ;;
+ "0x1572"|"0x154c")
+ MODEL="Intel-X710"
+ ;;
+ "0x101e")
+ MODEL="Mellanox-CX6DX"
+ ;;
+ *)
+ MODEL="virtual"
+ esac
+ fi
+}
+
+
function get_pci_addr () {
# Get PCI address in <domain>:<bus:<device>.<func> format from linux network
@@ -424,13 +535,33 @@ function get_pci_addr () {
PCI_ADDR=$(basename $(readlink /sys/class/net/${NETDEV}/device)) || {
die "Failed to get PCI address of linux network interface!"
}
- fi
- if [ ! -d /sys/bus/pci/devices/${PCI_ADDR} ]; then
- die "PCI device ${NETDEV} doesn't exist!"
+ if [ ! -d /sys/bus/pci/devices/${PCI_ADDR} ]; then
+ die "PCI device ${PCI_ADDR} doesn't exist!"
+ fi
+ else
+ die "Can't get device info of interface ${NETDEV}!"
fi
}
+function get_vfio_group () {
+
+ # Get the VFIO group of a pci device.
+ #
+ # Variables read:
+ # - PCI_ADDR - PCI address of a device.
+ # Variables set:
+ # - VFIO_GROUP - The VFIO group of the PCI device.
+
+ if [[ -d /sys/bus/pci/devices/${PCI_ADDR}/iommu_group ]]; then
+ VFIO_GROUP="$(basename\
+ $(readlink /sys/bus/pci/devices/${PCI_ADDR}/iommu_group)\
+ )" || {
+ die "PCI device ${PCI_ADDR} does not have an iommu group!"
+ }
+ fi
+}
+
function get_vlan_filter () {
# Get VLAN stripping filter from PF searched by mac adress.
@@ -467,6 +598,55 @@ function installed () {
}
+function parse_env_variables () {
+
+ # Parse environment variables.
+ #
+ # Variables read, set or exported: Multiple,
+ # see the code for the current list.
+
+ set -exuo pipefail
+
+ IFS=@ read -a TG_NETMACS <<< "${CSIT_TG_INTERFACES_PORT_MAC}"
+ IFS=@ read -a TG_PCIDEVS <<< "${CSIT_TG_INTERFACES_PORT_PCI}"
+ IFS=@ read -a TG_DRIVERS <<< "${CSIT_TG_INTERFACES_PORT_DRV}"
+ IFS=@ read -a TG_VLANS <<< "${CSIT_TG_INTERFACES_PORT_VLAN}"
+ IFS=@ read -a TG_MODELS <<< "${CSIT_TG_INTERFACES_PORT_MODEL}"
+ IFS=@ read -a DUT1_NETMACS <<< "${CSIT_DUT1_INTERFACES_PORT_MAC}"
+ IFS=@ read -a DUT1_PCIDEVS <<< "${CSIT_DUT1_INTERFACES_PORT_PCI}"
+ IFS=@ read -a DUT1_DRIVERS <<< "${CSIT_DUT1_INTERFACES_PORT_DRV}"
+ IFS=@ read -a DUT1_VLANS <<< "${CSIT_DUT1_INTERFACES_PORT_VLAN}"
+ IFS=@ read -a DUT1_MODELS <<< "${CSIT_DUT1_INTERFACES_PORT_MODEL}"
+
+ for port in $(seq "${#TG_NETMACS[*]}"); do
+ CSIT_TG_INTERFACES+=$(cat << EOF
+ port$((port-1)):
+ mac_address: "${TG_NETMACS[$((port-1))]}"
+ pci_address: "${TG_PCIDEVS[$((port-1))]}"
+ link: "link$((port-1))"
+ model: ${TG_MODELS[$((port-1))]}
+ driver: "${TG_DRIVERS[$((port-1))]}"
+ vlan: ${TG_VLANS[$((port-1))]}
+EOF
+ )
+ CSIT_TG_INTERFACES+=$'\n'
+ done
+ for port in $(seq "${#DUT1_NETMACS[*]}"); do
+ CSIT_DUT1_INTERFACES+=$(cat << EOF
+ port$((port-1)):
+ mac_address: "${DUT1_NETMACS[$((port-1))]}"
+ pci_address: "${DUT1_PCIDEVS[$((port-1))]}"
+ link: "link$((port-1))"
+ model: ${DUT1_MODELS[$((port-1))]}
+ driver: "${DUT1_DRIVERS[$((port-1))]}"
+ vlan: ${DUT1_VLANS[$((port-1))]}
+EOF
+ )
+ CSIT_DUT1_INTERFACES+=$'\n'
+ done
+}
+
+
function print_env_variables () {
# Get environment variables prefixed by CSIT_.
@@ -485,7 +665,6 @@ function read_env_variables () {
# - ${@} - Variables passed as an argument.
# Variables read, set or exported: Multiple,
# see the code for the current list.
- # TODO: Do we need to list them and their meanings?
set -exuo pipefail
@@ -495,18 +674,17 @@ function read_env_variables () {
declare -gA DCR_UUIDS
DCR_UUIDS+=([tg]="${CSIT_TG_UUID}")
DCR_UUIDS+=([dut1]="${CSIT_DUT1_UUID}")
- TG_PCIDEVS=("${CSIT_TG_INTERFACES_PORT1_PCI}")
- TG_DRIVERS=("${CSIT_TG_INTERFACES_PORT1_DRV}")
- TG_VLANS+=("${CSIT_TG_INTERFACES_PORT1_VLAN}")
- TG_PCIDEVS+=("${CSIT_TG_INTERFACES_PORT2_PCI}")
- TG_DRIVERS+=("${CSIT_TG_INTERFACES_PORT2_DRV}")
- TG_VLANS+=("${CSIT_TG_INTERFACES_PORT2_VLAN}")
- DUT1_PCIDEVS=("${CSIT_DUT1_INTERFACES_PORT1_PCI}")
- DUT1_DRIVERS=("${CSIT_DUT1_INTERFACES_PORT1_DRV}")
- DUT1_VLANS+=("${CSIT_DUT1_INTERFACES_PORT1_VLAN}")
- DUT1_PCIDEVS+=("${CSIT_DUT1_INTERFACES_PORT2_PCI}")
- DUT1_DRIVERS+=("${CSIT_DUT1_INTERFACES_PORT2_DRV}")
- DUT1_VLANS+=("${CSIT_DUT1_INTERFACES_PORT2_VLAN}")
+
+ IFS=@ read -a TG_NETMACS <<< "${CSIT_TG_INTERFACES_PORT_MAC}"
+ IFS=@ read -a TG_PCIDEVS <<< "${CSIT_TG_INTERFACES_PORT_PCI}"
+ IFS=@ read -a TG_DRIVERS <<< "${CSIT_TG_INTERFACES_PORT_DRV}"
+ IFS=@ read -a TG_VLANS <<< "${CSIT_TG_INTERFACES_PORT_VLAN}"
+ IFS=@ read -a TG_MODELS <<< "${CSIT_TG_INTERFACES_PORT_MODEL}"
+ IFS=@ read -a DUT1_NETMACS <<< "${CSIT_DUT1_INTERFACES_PORT_MAC}"
+ IFS=@ read -a DUT1_PCIDEVS <<< "${CSIT_DUT1_INTERFACES_PORT_PCI}"
+ IFS=@ read -a DUT1_DRIVERS <<< "${CSIT_DUT1_INTERFACES_PORT_DRV}"
+ IFS=@ read -a DUT1_VLANS <<< "${CSIT_DUT1_INTERFACES_PORT_VLAN}"
+ IFS=@ read -a DUT1_MODELS <<< "${CSIT_DUT1_INTERFACES_PORT_MODEL}"
}
@@ -517,13 +695,18 @@ function set_env_variables () {
# Variables read:
# - DCR_UUIDS - Docker Container UUIDs.
# - DCR_PORTS - Docker Container's SSH ports.
- # - DUT1_NETMACS - List of network devices MAC addresses of DUT1 container.
- # - DUT1_PCIDEVS - List of PCI addresses of devices of DUT1 container.
+ # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
+ # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
+ # - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
# - DUT1_DRIVERS - List of interface drivers to DUT1 container.
- # - TG_NETMACS - List of network devices MAC addresses of TG container.
- # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
+ # - DUT1_VLANS - List of interface vlans to TG container.
+ # - DUT1_MODEL - List of interface models to TG container.
+ # - TG_NETDEVS - List of network devices allocated to TG container.
+ # - TG_PCIDEVS - List of PCI addresses allocated to TG container.
+ # - TG_NETMACS - List of MAC addresses allocated to TG container.
# - TG_DRIVERS - List of interface drivers to TG container.
- # Variables set: TODO.
+ # - TG_VLANS - List of interface vlans to TG container.
+ # - TG_MODEL - List of interface models to TG container.
set -exuo pipefail
@@ -531,7 +714,7 @@ function set_env_variables () {
CSIT_TG_HOST="$(hostname --all-ip-addresses | awk '{print $1}')" || {
die "Reading hostname IP address failed!"
}
- CSIT_TG_PORT="${DCR_PORTS[tg]#*:}"
+ CSIT_TG_PORT="${DCR_PORTS[tg]##*:}"
CSIT_TG_UUID="${DCR_UUIDS[tg]}"
CSIT_TG_ARCH="$(uname -i)" || {
die "Reading machine architecture failed!"
@@ -539,28 +722,25 @@ function set_env_variables () {
CSIT_DUT1_HOST="$(hostname --all-ip-addresses | awk '{print $1}')" || {
die "Reading hostname IP address failed!"
}
- CSIT_DUT1_PORT="${DCR_PORTS[dut1]#*:}"
+ CSIT_DUT1_PORT="${DCR_PORTS[dut1]##*:}"
CSIT_DUT1_UUID="${DCR_UUIDS[dut1]}"
CSIT_DUT1_ARCH="$(uname -i)" || {
die "Reading machine architecture failed!"
}
- CSIT_TG_INTERFACES_PORT1_MAC="${TG_NETMACS[0]}"
- CSIT_TG_INTERFACES_PORT1_PCI="${TG_PCIDEVS[0]}"
- CSIT_TG_INTERFACES_PORT1_DRV="${TG_DRIVERS[0]}"
- CSIT_TG_INTERFACES_PORT1_VLAN="${TG_VLANS[0]}"
- CSIT_TG_INTERFACES_PORT2_MAC="${TG_NETMACS[1]}"
- CSIT_TG_INTERFACES_PORT2_PCI="${TG_PCIDEVS[1]}"
- CSIT_TG_INTERFACES_PORT2_DRV="${TG_DRIVERS[1]}"
- CSIT_TG_INTERFACES_PORT2_VLAN="${TG_VLANS[1]}"
- CSIT_DUT1_INTERFACES_PORT1_MAC="${DUT1_NETMACS[0]}"
- CSIT_DUT1_INTERFACES_PORT1_PCI="${DUT1_PCIDEVS[0]}"
- CSIT_DUT1_INTERFACES_PORT1_DRV="${DUT1_DRIVERS[0]}"
- CSIT_DUT1_INTERFACES_PORT1_VLAN="${DUT1_VLANS[0]}"
- CSIT_DUT1_INTERFACES_PORT2_MAC="${DUT1_NETMACS[1]}"
- CSIT_DUT1_INTERFACES_PORT2_PCI="${DUT1_PCIDEVS[1]}"
- CSIT_DUT1_INTERFACES_PORT2_DRV="${DUT1_DRIVERS[1]}"
- CSIT_DUT1_INTERFACES_PORT2_VLAN="${DUT1_VLANS[1]}"
+ OIFS="$IFS" IFS=@
+ set -a
+ CSIT_TG_INTERFACES_PORT_MAC="${TG_NETMACS[*]}"
+ CSIT_TG_INTERFACES_PORT_PCI="${TG_PCIDEVS[*]}"
+ CSIT_TG_INTERFACES_PORT_DRV="${TG_DRIVERS[*]}"
+ CSIT_TG_INTERFACES_PORT_VLAN="${TG_VLANS[*]}"
+ CSIT_TG_INTERFACES_PORT_MODEL="${TG_MODELS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_MAC="${DUT1_NETMACS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_PCI="${DUT1_PCIDEVS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_DRV="${DUT1_DRIVERS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_VLAN="${DUT1_VLANS[*]}"
+ CSIT_DUT1_INTERFACES_PORT_MODEL="${DUT1_MODELS[*]}"
set +a
+ IFS="$OIFS"
}
@@ -598,9 +778,21 @@ function start_topology_containers () {
# Override access to PCI bus by attaching a filesystem mount to the
# container.
dcr_stc_params+="--mount type=tmpfs,destination=/sys/bus/pci/devices "
- # Mount vfio to be able to bind to see bound interfaces. We cannot use
- # --device=/dev/vfio as this does not see newly bound interfaces.
- dcr_stc_params+="--volume /dev/vfio:/dev/vfio "
+ # Mount vfio devices to be able to use VFs inside the container.
+ vfio_bound="false"
+ for PCI_ADDR in ${DUT1_PCIDEVS[@]}; do
+ get_krn_driver
+ if [[ ${KRN_DRIVER} == "vfio-pci" ]]; then
+ get_vfio_group
+ dcr_stc_params+="--device /dev/vfio/${VFIO_GROUP} "
+ vfio_bound="true"
+ fi
+ done
+ if ! ${vfio_bound}; then
+ dcr_stc_params+="--volume /dev/vfio:/dev/vfio "
+ fi
+ # Disable manipulation with hugepages by VPP.
+ dcr_stc_params+="--volume /dev/null:/etc/sysctl.d/80-vpp.conf "
# Mount docker.sock to be able to use docker deamon of the host.
dcr_stc_params+="--volume /var/run/docker.sock:/var/run/docker.sock "
# Mount /opt/boot/ where VM kernel and initrd are located.